#include <iostream>
using namespace std;
struct digit{
	int pos;
	char ch;
};
digit tree [5000000];
string s;
int k;
void build (int l, int r, int pos){
	if (l == r){
		tree [pos].pos = l;
		tree [pos].ch = s [l];
	}
	else{
		int mid = (l + r) / 2;
		build (l, mid, 2 * pos);
		build (mid + 1, r, 2 * pos + 1);
		if (tree [2 * pos].ch >= tree [2 * pos + 1].ch){
			tree [pos].ch = tree [2 * pos].ch; tree [pos].pos = tree [2 * pos].pos;
		}
		else{
			tree [pos].ch = tree [2 * pos + 1].ch; tree [pos].pos = tree [2 * pos + 1].pos;
		}
	}
}
digit query (int l, int r, int pos, int ql, int qr){
	if (l > qr || r < ql){
		digit d; d.ch = '0' - 1;
		return d;
	}
	if (l >= ql && r <= qr) return tree [pos];
	int mid = (l + r) / 2;
	digit d1 = query (l, mid, 2 * pos, ql, qr), d2 = query (mid + 1, r, 2 * pos + 1, ql, qr);
	if (d1.ch >= d2.ch) return d1;
	else return d2;
}
int main (){

	cin >> s >> k;
	int pos = 0, k1 = k, n = s.size ();
	build (0, n - 1, 1);
	for (int i = 0; i < n - k; i ++){
		digit d = query (0, n - 1, 1, pos, pos + k1);
		cout << d.ch;
		k1 -= d.pos - pos;
		pos = d.pos + 1;
	}
	cout << '\n';

	return 0;
}
