#include <iostream>
using namespace std;
string dp[256];
bool used[256][256];
string rev(string s) {
    int n=s.size();
    for (int i=0;i<n/2;i++) swap(s[i],s[n-i-1]);
    return s;
}
string pro(int num, string s) {
    int n=s.size();
    int c, res;
    c=0;
    for (int i=0;i<n;i++) {
        res=(s[i]-'0')*num+c;
        if (res>10) {
            c=res/10;
            res=res%10;
        } else c=0;
        s[i]=res+'0';
    }
    while (c>0) {
        s+=c%10+'0';
        c/=10;
    }
    return s;
}
bool strcheck(string a, string b) {
    int n1, n2;
    n1=a.size();
    n2=b.size();
    if (n1>n2) return false;
    if (n2>n1) return true;
    for (int i=n1;i>=0;i--) {
        if (a[i]>b[i]) return false;
        if (b[i]>a[i]) return true;
    }
    return false;
}
int main () {
    int n;
    cin >> n;
    dp[0]="1\0";
    string s;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=i;j++) {
            if (!used[i-j][j]) {
                s=pro(j,dp[i-j]);
                if (strcheck(dp[i],s)) {
                    dp[i]=s;
                    for (int k=0;k<=i-j;k++) used[i][k]=used[i-j][k];
                    used[i][j]=true;
                }
            }
        }
    }
    cout << rev(dp[n]) << '\n';
    return 0;
}
