#include<iostream>
#include<vector>

using namespace std;

#define base 1000000000
#define zeroes 9

long long countDigits(long long x)
{
    long long res=1;

    while(x>=10)
    {
        x/=10;
        res++;
    }

    return res;
}

void output(vector<long long> v)
{
    long long i,j,x;

    cout<<v.back();

    for(i=(long long)v.size()-2;i>=0;i--)
    {
        //cout<<i<<endl;
        x=countDigits(v[i]);
        for(j=0;j<zeroes-x;j++)
            cout<<"0";
        cout<<v[i];
    }
}

long long compare(vector<long long> a,vector<long long> b)
{
    if(a.size()!=b.size())
        return (a.size()<b.size())?-1:1;

    long long i;

    for(i=(long long)a.size()-1;i>=0;i--)
    {
        if(a[i]!=b[i])
            return (a[i]<b[i])?-1:1;
    }

    return 0;
}

vector<long long> add(vector<long long> a,vector<long long> b)
{
    if(compare(a,b)==-1)swap(a,b);

    long long i,cnt1=(long long)a.size(),cnt2=(long long)b.size(),pr=0;
    //vector<long long> res;

    for(i=0;i<cnt1;i++)
    {
        if(cnt2<=i)
            pr+=a[i];
        else
            pr+=a[i]+b[i];
        a[i]=pr%base;
        pr=pr/base;
    }
    if(pr)a.push_back(pr);

    return a;
}

vector<long long> multiplySmall(vector<long long> a,long long b)
{
    long long i,cnt=(long long)a.size(),pr=0;
    vector<long long> res;

    for(i=0;i<cnt;i++)
    {
        pr+=b*a[i];
        res.push_back(pr%base);
        pr/=base;
    }
    if(pr)
    {
        res.push_back(pr);
    }

    return res;
}

vector<long long> dp[205][205];
bool b[205][205];

vector<long long> solve(long long n,long long num)
{
    vector<long long> p1,p2;

    if(n==0)
    {
        p1.push_back(1);
        return p1;
    }
    if(num>n)
    {
        p1.push_back(0);
        return p1;
    }
    if(b[n][num])return dp[n][num];

    b[n][num]=1;

    p1=multiplySmall(solve(n-num,num+1),num);
    p2=solve(n,num+1);

    if(compare(p1,p2)>=0)
        dp[n][num]=p1;
    else
        dp[n][num]=p2;

    return dp[n][num];
}

int main ()
{
    long long n;

    cin>>n;
    //n=200;

    output(solve(n,1));

    cout<<endl;

    return 0;
}
