#include <iomanip>
#include <iostream>
#include <vector>
using namespace std;
unsigned long long euclid (unsigned long long a, unsigned long long b){
	if (a < b) swap (a, b);
	while (b > 0){
		unsigned long long c = a % b;
		a = b; b = c;
	}
	return a;
}
vector <unsigned long long> ostatyci;
int main (){

	string a, b;
	cin >> a >> b;
	int n = a.size (), m = b.size ();
	unsigned long long x = 0, y = 0, z = 0, t = 0, nok = 0;
	int i, j;
	for (i = 0; i < n; i ++){
		if (a [i] == '.') break;
		else x = x * 10 + a [i] - '0';
	}
	for (j = 0; j < m; j ++){
		if (b [j] == '.') break;
		else y = y * 10 + b [j] - '0';
	}
	int integer = x + y;
	if (i == n && j == m){
		cout << integer << '\n';
		return 0;
	}
	
	i ++; j ++;
	x = 0; y = 0;
	unsigned long long d1 = 1, d2 = 1, br1 = 0, br2 = 0, d3 = 0, d4 = 0;
	for (i; i < n; i ++){
		if (a [i] == '(') break;
		x = x * 10 + a [i] - '0';
		d1 *= 10; br1 ++;
	}
	for (j; j < m; j ++){
		if (b [j] == '(') break;
		y = y * 10 + b [j] - '0';
		d2 *= 10; br2 ++;
	}
	if (i >= n && j >= m){
		nok = max (d1, d2);
		unsigned long long nonperiodic = x * (nok / d1) + y * (nok / d2);
		if (nonperiodic >= nok){
			integer ++;
			nonperiodic %= nok;
		}
		if (nonperiodic == 0) cout << integer << '\n';
		else cout << integer << '.' << setfill ('0') << setw (max (br1, br2)) << nonperiodic << '\n';
		return 0;
	}

	i ++; j ++;
	for (i; i < n; i ++){
		if (a [i] == ')') break;
		z = z * 10 + a [i] - '0';
		d3 = d3 * 10 + 9;
	}
	for (j; j < m; j ++){
		if (b [j] == ')') break;
		t = t * 10 + b [j] - '0';
		d4 = d4 * 10 + 9;
	}
	if (d3 == 0) d3 = 1;
	if (d4 == 0) d4 = 1;
	d3 *= d1;
	d4 *= d2;
	nok = (d3 / euclid (d3, d4)) * d4;
	unsigned long long fract = x * (nok / d1) + y * (nok / d2) + z * (nok / d3) + t * (nok / d4);
	if (fract >= nok){
		integer ++;
		fract %= nok;
	}
	if (fract == 0){
		cout << integer << '\n';
		return 0;
	}
	cout << integer << '.';
	int sz = 0;
	string ans = "";
	while (true){
		for (int k = 0; k < sz; k ++)
			if (ostatyci [k] == fract){
				for (int p = 0; p < k; p ++) cout << ans [p];
				cout << '(';
				for (int p = k; p < ans.size (); p ++) cout << ans [p];
				cout << ")\n";
				return 0;
			}
		sz ++;
		ostatyci.push_back (fract);
		ans += char (fract * 10 / nok + '0');
		fract = fract * 10 % nok;
		if (fract == 0){
			cout << ans << '\n';
			return 0;
		}
	}

	return 0;
}
