#include <iostream>
#include <string>
#define MAXSZ 1000003
using namespace std;
string s;
int k;
int tree[8 * MAXSZ];
int m[MAXSZ];
void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = l;
        return;
    }
    build(v<<1, l, (l+r)>>1);
    build((v<<1)+1, ((l+r)>>1)+1, r);
    if (m[tree[v<<1]] > m[tree[(v<<1)+1]] || (m[tree[v<<1]] == m[tree[(v<<1)+1]] && tree[v<<1] < tree[(v<<1)+1]))
        tree[v] = tree[v<<1];
    else tree[v] = tree[(v<<1)+1];
}
int get(int v, int l, int r, int x, int y)
{
    if (l > y || r < x) return -1;
    if (l >= x && r <= y) return tree[v];
    int first = get(v<<1, l, (l+r)>>1, x, y);
    int second = get((v<<1)+1, ((l+r)>>1)+1, r, x, y);
    if (m[first] > m[second] || (m[first] == m[second] && first < second)) return first;
    return second;
}
int main()
{
    cin >> s;
    cin >> k;
    int sz = s.size();
    int cnt = sz-k;
    for (int i = 1; i <= sz; i++)
        m[i] = s[i-1]-'0';
        build(1, 1, sz);
    int idx = 0;
    for (int i = 1; i <= cnt; i++)
    {
        idx = get(1, 1, sz, idx+1, sz-cnt+i);
        cout << m[idx];
    }
    cout << endl;
}
