#include <iostream>
#include <string>
#define MAXSZ 1000003
using namespace std;
string s;
int k;
int tree[8 * MAXSZ];
void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = l;
        return;
    }
    build(v<<1, l, (l+r)>>1);
    build((v<<1)+1, ((l+r)>>1)+1, r);
    if (s[tree[v<<1]-1] > s[tree[(v<<1)+1]-1] || (s[tree[v<<1]-1] == s[tree[(v<<1)+1]-1] && tree[v<<1] < tree[(v<<1)+1]))
        tree[v] = tree[v<<1];
    else tree[v] = tree[(v<<1)+1];
}
int get(int v, int l, int r, int x, int y)
{
    if (l > y || r < x) return -1;
    if (l >= x && r <= y) return tree[v];
    int first = get(v<<1, l, (l+r)>>1, x, y);
    int second = get((v<<1)+1, ((l+r)>>1)+1, r, x, y);
    if (s[first-1] > s[second-1] || (s[first-1] == s[second-1] && first < second)) return first;
    return second;
}
int main()
{
    cin >> s;
    cin >> k;
    int sz = s.size();
    int cnt = sz-k;
    build(1, 1, sz);
    int idx = 0;
    cout << s[idx-1];
    for (int i = 1; i <= cnt; i++)
    {
        idx = get(1, 1, sz, idx+1, sz-cnt+i);
        cout << s[idx-1];
    }
    cout << endl;
}
